// Menge.java                                   AZ 2004
//                                              MM 2009

import java.util.*;                          // HashSet

/**
 * Mengentemplate, typgebundene Menge mit Iterator.
 * @author Andreas Zerbst
 */
public class Menge<T>
{
/**
 * Menge von Objekten eines Typs T.
 */
  private HashSet<T> menge;

/**
 * Mengeniterator.
 */
  private Iterator<T> it;

/* ------------------------------------------------- */
                                         // Konstruktor
/**
 * Konstruktor,
 * erzeugt Mengenobjekt, setzt Iterator zurueck.
 */
  protected Menge()
  {
    menge = new HashSet<T>();
    it = null;
  }

/* ------------------------------------------------- */
                                    // Service-Methoden
/**
 * Liefert das erste Elemente.
 * @return erstes Element der Menge
 *         (null - keins vorhanden)
 */
  protected T erstesElement()
  {
    it = menge.iterator();
    return naechstesElement();
  }

/**
 * Ermittlt das naechste Element
 * @return naechstes Element der Menge
 *         (null - keins mehr vorhanden)
 */
  protected T naechstesElement()
  {
    if( it == null) return null;
    if( it.hasNext()) return it.next();
    return null;
  }

/**
 * Fuegt ein Element zur Menge dazu.
 * @param o Element vom Typ T
 * @return true, falls Element aufgenommen wurde
 */
  protected boolean addElement( T o)
  {
    it = null;
    return menge.add(o);
  }

 /**
 * Anzahl der Elemente.
 * @return Anzahl der Elemente
 */
  public int anzahl()
  {
    return menge.size();
  }

/* ------------------------------------------------- */
/**
 * Darstellung aller Elemente.
 * @return Elemente der Klasse als String
 */
  public String toString()
  {
    String str = "";
    T e = erstesElement();
    while( e != null)
    {
      str += e + "\n";
      e = naechstesElement();
    }
    return str;
  }

/* ------------------------------------------------- */
/**
 * Test des Template Menge, Datentyp T sei String.
 */
  public static void main( String[] args)
  {
    Menge<String> stringMenge = new Menge<String>();

    stringMenge.addElement( "Anna");
    stringMenge.addElement( "Jonas");
    stringMenge.addElement( "Anna");
    stringMenge.addElement( "Frida");

    System.out.println( stringMenge);
  }
}
